D Programming Language 1.0

Last update Mon Dec 31 10:53:28 2012

# std.date

Dates are represented in several formats. The date implementation revolves around a central type, d_time, from which other formats are converted to and from. Dates are calculated using the Gregorian calendar.
References:
Gregorian calendar (Wikipedia)
Source:
std/date.d
License:
Distributed under the Boost Software License, Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at Boost License 1.0)
Authors:
Walter Bright

alias d_time;
  is a signed arithmetic type giving the time elapsed since January 1, 1970. Negative values are for dates preceding 1970. The time unit used is Ticks. Ticks are milliseconds or smaller intervals.
  The usual arithmetic operations can be performed on d_time, such as adding, subtracting, etc. Elapsed time in Ticks can be computed by subtracting a starting d_time from an ending d_time.
const d_time d_time_nan;
  A value for d_time that does not represent a valid time.
struct Date;
  Time broken down into its components.
  int year;
    use int.min as "nan" year value
  int month;
    1..12
  int day;
    1..31
  int hour;
    0..23
  int minute;
    0..59
  int second;
    0..59
  int ms;
    0..999
  int weekday;
    0: not specified, 1..7: Sunday..Saturday
  int tzcorrection;
    -1200..1200 correction in hours
  void parse(string s);
    Parse date out of string s[] and store it in this Date instance.
TicksPerSecond
  Will be at least 1000
void toISO8601YearWeek(d_time t, out int year, out int week);
  Compute year and week [1..53] from t. The ISO 8601 week 1 is the first week of the year that includes January 4. Monday is the first day of the week.
  References:
  ISO 8601 (Wikipedia)
int YearFromTime(d_time t);
  Calculates the year from the d_time t.
int inLeapYear(d_time t);
  Determines if d_time t is a leap year.
  A leap year is every 4 years except years ending in 00 that are not divsible by 400.
  Returns:
  !=0 if it is a leap year.
  References:
  Wikipedia
int MonthFromTime(d_time t);
  Calculates the month from the d_time t.
  Returns:
  Integer in the range 0..11, where 0 represents January and 11 represents December.
int DateFromTime(d_time t);
  Compute which day in a month a d_time t is.
  Returns:
  Integer in the range 1..31
int WeekDay(d_time t);
  Compute which day of the week a d_time t is.
  Returns:
  Integer in the range 0..6, where 0 represents Sunday and 6 represents Saturday.
d_time UTCtoLocalTime(d_time t);
  Convert from UTC to local time.
d_time LocalTimetoUTC(d_time t);
  Convert from local time to UTC.
int DateFromNthWeekdayOfMonth(int year, int month, int weekday, int n);
  Determine the date in the month, 1..31, of the nth weekday.
  Params:

  int year | year
  int month | month, 1..12
  int weekday | day of week 0..6 representing Sunday..Saturday
  int n | nth occurrence of that weekday in the month, 1..5, where 5 also means "the last occurrence in the month"

  Returns:
  the date in the month, 1..31, of the nth weekday
int daysInMonth(int year, int month);
  Determine the number of days in a month, 1..31.
  Params:

  int month | 1..12

string toString(d_time time);
  Converts UTC time into a text string of the form: "Www Mmm dd hh:mm:ss GMT+-TZ yyyy". For example, "Tue Apr 02 02:04:57 GMT-0800 1996". If time is invalid, i.e. is d_time_nan, the string "Invalid date" is returned.
  Example:

        d_time lNow;
        char[] lNowString;

        // Grab the date and time relative to UTC
        lNow = std.date.getUTCtime();
        // Convert this into the local date and time for display.
        lNowString = std.date.toString(lNow);

string toUTCString(d_time t);
  Converts t into a text string of the form: "Www, dd Mmm yyyy hh:mm:ss UTC". If t is invalid, "Invalid date" is returned.
string toDateString(d_time time);
  Converts the date portion of time into a text string of the form: "Www Mmm dd yyyy", for example, "Tue Apr 02 1996". If time is invalid, "Invalid date" is returned.
string toTimeString(d_time time);
  Converts the time portion of t into a text string of the form: "hh:mm:ss GMT+-TZ", for example, "02:04:57 GMT-0800". If t is invalid, "Invalid date" is returned. The input must be in UTC, and the output is in local time.
d_time parse(string s);
  Parses s as a textual date string, and returns it as a d_time. If the string is not a valid date, is returned.
d_time getUTCtime();
  Get current UTC time.
typedef DosFileTime;
  Type representing the DOS file date/time format.
d_time toDtime(DosFileTime time);
  Convert from DOS file date/time to d_time.
DosFileTime toDosFileTime(d_time t);
  Convert from d_time to DOS file date/time.

Copyright Digital Mars 2000 - 2010. | Page generated by Ddoc.